static unsigned long long_mul(unsigned long n1, unsigned long n2)
{
  unsigned long res = 0;
  unsigned long s;
  unsigned n;

  while(n1)
  {
    for(s=1,n=n2;s <= n1;)
    {
      s <<= 1;
      n <<= 1;
    }
    res += n;
    n1 ^= (s>>1);
  }
  return res;
}

inline unsigned mul_60(unsigned n1)
{
  return (n1 << 6) - (n1 << 2);
}

// returns a value that is incremented every second

inline unsigned long human2unixtime(unsigned short year, unsigned char month, unsigned char day, unsigned char hour,
  unsigned char min, unsigned char sec)
{
  static unsigned char __based (__segname("_CODE")) month_lengths[] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
  unsigned n;
  unsigned long retval;
  //    *** This will cease to work at Sunday, February 7, 2106 6:28:15 AM GMT time! ***
  //    *** Remember to change the datatypes to 64-bit before that! ***
  // days since epoch at the beginning of the current year
  retval = (unsigned long)(((year-1970)* 365) + (((year-1)-1968)>>2));
  // + days since the beginning of the current year

  for(n=month-1;n--;)
  {
    retval += month_lengths[n];
    // add current year's leap day
    if(n==1 && !((year-1972)&3))
      retval++;
  }
  retval += day-1;

  // seconds from epoch at the beginning of the current day
//  retval *= 86400;
  long_mul(retval, 86400);
  // + seconds since the beginning of the current day
//  retval += long_mul(hour, 60*60) + min*60 + sec;
  retval += long_mul(hour, 60*60) + mul_60(min) + sec;

  return retval;
}

extern unsigned __based(__segname("_CODE")) timer_var;
unsigned long __based(__segname("_CODE")) gtime;
extern unsigned __based(__segname("_CODE")) clock_ticks;
static unsigned long dos_time(/*unsigned unused*/)
{
  unsigned year;
  unsigned char month;
  unsigned char day;
  unsigned char hour;
  unsigned char minute;
  unsigned char second;

  if(timer_var < 18)
    return gtime;
  timer_var = 0;

  __asm
  {
    mov ah, 0x2A
    int 0x21 // get date
    
    mov year, cx // year
    mov month, dh
    mov day, dl
    
    mov ah, 0x2C
    int 0x21 // get time

    mov hour, ch
    mov minute, cl
    mov second, dh
  }
  
  return gtime = human2unixtime(year, month, day, hour, minute, second);
}

#define ttime(a) dos_time()
