struct in_addr
{
  unsigned long s_addr;
};

struct sockaddr_in
{
  unsigned short sin_family;
  unsigned short sin_port;
  struct in_addr sin_addr;
  char sin_zero;
};

int close_socket(int socket);

#define SOCK_NONBLOCK 2

#define INADDR_ANY 0

void _service_packets(void);
#pragma aux _service_packets = \
  "xor ax, ax" \
  "int 0x61";

#define AF_INET 0

#define SOCK_STREAM 0
#define SOCK_DGRAM 1
int socket(int domain, int type, int protocol);

int bind(int sockfd, const struct sockaddr_in __far *addr, unsigned addrlen);

int connect(int sockfd, const struct sockaddr_in __far *addr, unsigned addrlen);

int listen(int sockfd, int backlog);

int getpeername(int sockfd, struct sockaddr_in __far *addr, unsigned *addrlen);

int getsockname(int sockfd, struct sockaddr_in __far *addr, unsigned *addrlen);

#define MSG_DONTWAIT 0x01

int recv(int sockfd, void __far *buf, unsigned len, int flags);

unsigned recvfrom(int sockfd, void __far *buf, unsigned len, int flags,
                  struct sockaddr_in __far *src_addr, unsigned *addrlen);

int accept(int sockfd, struct sockaddr_in __far *addr, unsigned *addrlen);

int send(int sockfd, const void __far *buf, unsigned len, int flags);

unsigned sendto(int sockfd, const void __far *buf, unsigned len, int flags,
                const struct sockaddr_in __far *dest_addr, unsigned addrlen);
